    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------
    028     * ImageEncoder.java
    029     * -------------------
    030     * (C) Copyright 2004, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   -;
    034     *
    035     * $Id: ImageEncoder.java,v 1.3.2.1 2005/10/25 20:41:46 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 01-Aug-2004 : Initial version (RA);
    040     *
    041     */
    042
    043    package org.jfree.chart.encoders;
    044
    045    import java.io.OutputStream;
    046    import java.io.IOException;
    047    import java.awt.image.BufferedImage;
    048
    049    /**
    050     * Interface for abstracting different types of image encoders.
    051     *
    052     * @author Richard Atkinson
    053     */
    054    public interface ImageEncoder {
    055
    056        /**
    057         * Encodes an image in a particular format.
    058         *
    059         * @param bufferedImage  The image to be encoded.
    060         *
    061         * @return The byte[] that is the encoded image.
    062         *
    063         * @throws IOException
    064         */
    065        public byte[] encode(BufferedImage bufferedImage) throws IOException;
    066
    067
    068        /**
    069         * Encodes an image in a particular format and writes it to an OutputStream.
    070         *
    071         * @param bufferedImage  The image to be encoded.
    072         * @param outputStream  The OutputStream to write the encoded image to.
    073         * @throws IOException
    074         */
    075        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    076            throws IOException;
    077
    078        /**
    079         * Get the quality of the image encoding.
    080         *
    081         * @return A float representing the quality.
    082         */
    083        public float getQuality();
    084
    085        /**
    086         * Set the quality of the image encoding (not supported by all
    087         * ImageEncoders).
    088         *
    089         * @param quality  A float representing the quality.
    090         */
    091        public void setQuality(float quality);
    092
    093        /**
    094         * Get whether the encoder should encode alpha transparency.
    095         *
    096         * @return Whether the encoder is encoding alpha transparency.
    097         */
    098        public boolean isEncodingAlpha();
    099
    100        /**
    101         * Set whether the encoder should encode alpha transparency (not
    102         * supported by all ImageEncoders).
    103         *
    104         * @param encodingAlpha  Whether the encoder should encode alpha
    105         *                       transparency.
    106         */
    107        public void setEncodingAlpha(boolean encodingAlpha);
    108
    109    }